   PROGRAM

 MAP
   MODULE('WIN API')
    ShellExecute(UNSIGNED,*CSTRING,*CSTRING,LONG=0,LONG=0,SIGNED=1),UNSIGNED,PASCAL,RAW,NAME('ShellExecuteA')
    END
    XLSX_Image(String,Long,Long,Long,Byte,Byte),Byte
 END

 INCLUDE('xlsxwriter.inc')

 ! --- FreeImage
 Include('cfiImgCt.inc'),Once   ! the image control
 Include('cfiDlgs.inc'),Once    ! the image control dialogs

xlsx   &xlsxwriter

FName  CString(256)
Cmd    CString('open')

Window WINDOW('Xlsx'),AT(,,312,107),FONT('MS Sans Serif',8,,FONT:regular),TIMER(100),SYSTEM,GRAY,DOUBLE
       BUTTON('  xlsx'),AT(50,38,100,14),USE(?Button)
     END

 CODE

    Open(Window)

    settarget(window)
    accept
      case event()
      of Event:Accepted
        case Field()
        OF ?Button
            xlsx &=NEW(xlsxwriter)

            FName=path()&'\Report.xlsx'
            xlsx.NewWorkbook(FName)
            worksheet#=xlsx.AddWorksheet('1')

            xlsx.ClearFormat()

            err# = xlsx.SetColumn(2,2, 7.57)  !   58  ( 50  + 2   4)
            err# = xlsx.SetRow(2,43.5)

            err# = xlsx.SetColumn(3,3,14.71)  !  108  (100  + 2   4)
            err# = xlsx.SetRow(3,81)

            err# = xlsx.SetColumn(4,4,29)     !  208  (200  + 2   4)
            err# = xlsx.SetRow(4,156)

            err# = xlsx.SetColumn(5,5,43.29)  !  308  (300  + 2   4)
            err# = xlsx.SetRow(5,231)

            If XLSX_Image('test.gif',2,2, 50,4,4).   !    50 
            If XLSX_Image('test.gif',3,3,100,4,4).   !   100 
            If XLSX_Image('test.gif',4,4,200,4,4).   !   200 
            If XLSX_Image('test.gif',5,5,300,4,4).   !   300 

            xlsx.Format.Border.Format = XLSX:BORDER_THIN
            xlsx.SetFormat()

            err# = xlsx.WriteBlank(2,2)
            err# = xlsx.WriteBlank(3,3)
            err# = xlsx.WriteBlank(4,4)
            err# = xlsx.WriteBlank(5,5)

            err# = xlsx.CloseWorkbook()

            dispose(xlsx)

            Err# = ShellExecute(0,Cmd,FName,,,10)

        end
        display
      end
    end

    close(window)

  ! ---  

XLSX_Image Procedure(xFileName_,xRow_,xCol_,xPixel_,xOffsetW_,xOffsetH_)

Loc:RetValue         BYTE(False)
theImage             FreeImageClass
Loc:Offset           LONG(0)
Loc:MaxSize          LONG
Loc:ThSize           LONG
Loc:Coeff            REAL
Loc:TmpFile          CSTRING(256)

  Code

  If theImage.iImage.Load(Clip(xFileName_)) = True

     Loc:MaxSize = Choose(theImage.ImageSize.Width > theImage.ImageSize.Height,theImage.ImageSize.Width,theImage.ImageSize.Height)

     Loc:ThSize = xPixel_  !    
     Loc:Coeff  = 1        ! 

     If Loc:ThSize > Loc:MaxSize
        Loc:Coeff  = Loc:MaxSize / Loc:ThSize
        Loc:ThSize = Loc:MaxSize
     end

     theImage.iImage.SetDotsPerMeterX(3780)   !   96 / = 3780 /
     theImage.iImage.SetDotsPerMeterY(3780)

     If theImage.iImage.Thumbnail(Loc:ThSize) = True

        theImage.iImage.SetSaveOption(PNG_Z_DEFAULT_COMPRESSION)

        Loc:TmpFile = Clip(LongPath(System{Prop:TempPath})) & Format(Random(1,999999),@n06) & '.png'

        If theImage.iImage.SaveAs(Loc:TmpFile,FIF_PNG) = True

           !    
           Loc:Offset = Abs(Round((theImage.ImageSize.Width - theImage.ImageSize.Height) / (2 * Loc:Coeff),1))

           If xlsx.InsertImage(xRow_,xCol_,Loc:TmpFile,                                                                |
                               xOffsetW_ + Choose(theImage.ImageSize.Width > theImage.ImageSize.Height,0,Loc:Offset),  |
                               xOffsetH_ + Choose(theImage.ImageSize.Width > theImage.ImageSize.Height,Loc:Offset,0),  |
                               1 / Loc:Coeff,1 / Loc:Coeff) = False

              If ~ErrorCode() then Loc:RetValue = True else Remove(Loc:TmpFile).
           else
              Remove(Loc:TmpFile)
           end
        end
     end
  else
     Message('  : ' & Clip(xFileName_))
  end

  Return(Loc:RetValue)